<template lang="pug">
  span.icon(
    :class="internalClass",
    @click="onClick"
  )
    svg.app-icon(viewBox="0 0 24 24")
      path(
        fill="currentColor",
        :d="path"
      )
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import camelCase from 'lodash/camelCase';
import get from 'lodash/get';
import * as mdi from '@mdi/js';

@Component({
  name: 'AppIcon',
})
class TheNavbar extends Vue {
  @Prop({
    type: String,
    default: '',
  })
  readonly icon!: string;

  @Prop({
    type: String,
    default: '',
    validator(value: string): boolean {
      return value ? ['small', 'medium', 'large'].includes(value) : true;
    },
  })
  readonly size!: string;

  @Prop({
    type: String,
    default: '',
  })
  readonly type!: string;

  get path() {
    const icon = camelCase(['mdi', this.icon].join('-'));
    const $path = get(mdi, icon, '');
    return $path;
  }

  get internalSize() {
    return this.size ? `is-${this.size}` : '';
  }

  get internalType() {
    return this.type ? `has-text-${this.type}` : '';
  }

  get internalClass() {
    const styles = [];

    if (this.internalSize) { styles.push(this.internalSize); }
    if (this.internalType) { styles.push(this.internalType); }

    return styles;
  }

  onClick(event: Event) {
    this.$emit('click', event);
  }
}

export default TheNavbar;
</script>

<style lang="sass" scoped>
svg.app-icon
  width: 100%
  height: auto
</style>
